-- name: [CS] Jeffy
-- description: Mario and Rosalina's son.

local E_MODEL_JEFFY = smlua_model_util_get_id("jeffy_geo")

local TEX_CUSTOM_LIFE_ICON = get_texture_info("j-life")

local TEXT_MOD_NAME = "JEFFY"

if not _G.charSelectExists then
    djui_popup_create("\\#ffffdc\\\n"..TEXT_MOD_NAME.."\nRequires the Character Select Mod\nto use as a Library!\n\nPlease turn on the Character Select Mod\nand Restart the Room!", 6)
    return 0
end

local VOICETABLE_JEFFY = {
    [CHAR_SOUND_ATTACKED] = 'J-Hurt.ogg',
    [CHAR_SOUND_DOH] = 'J-Oof.ogg',
    [CHAR_SOUND_DROWNING] = 'J-Drowning.ogg',
    [CHAR_SOUND_DYING] = 'J-Die.ogg',
    [CHAR_SOUND_GROUND_POUND_WAH] = 'J-GroundPound.ogg',
    [CHAR_SOUND_HAHA] = 'J-Landing.ogg',
    [CHAR_SOUND_HAHA_2] = 'J-Landing.ogg',
    [CHAR_SOUND_HERE_WE_GO] = 'J-Pencil.ogg',
    [CHAR_SOUND_HOOHOO] = 'J-UhUh.ogg',
    [CHAR_SOUND_MAMA_MIA] = 'J-IDEK.ogg',
    [CHAR_SOUND_OKEY_DOKEY] = 'J-Uh1.ogg',
    [CHAR_SOUND_ON_FIRE] = 'J-Burning.ogg',
    [CHAR_SOUND_OOOF] = 'J-Why.ogg',
    [CHAR_SOUND_OOOF2] = 'J-Why.ogg',
    [CHAR_SOUND_PUNCH_HOO] = 'J-Daddy1.ogg',
    [CHAR_SOUND_PUNCH_WAH] = 'J-Wah.ogg',
    [CHAR_SOUND_PUNCH_YAH] = 'J-Yah.ogg',
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'J-Uh7.ogg',
    [CHAR_SOUND_TWIRL_BOUNCE] = 'J-Uh7.ogg',
    [CHAR_SOUND_WAAAOOOW] = 'J-Falling.ogg',
    [CHAR_SOUND_WAH2] = 'J-Uh6.ogg',
    [CHAR_SOUND_WHOA] = 'J-Climb.ogg',
    [CHAR_SOUND_YAHOO] = 'J-Uh7.ogg',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = 'J-Uh2.ogg',
    [CHAR_SOUND_YAH_WAH_HOO] = 'J-Uh1.ogg',
    [CHAR_SOUND_YAWNING] = 'J-Sleep.ogg',
}

local PALETTE_JEFFY = {
    [PANTS]  = "0e1b3d",
    [SHIRT]  = "fcb201",
    [GLOVES] = "ffffff",
    [SHOES]  = "181818",
    [HAIR]   = "241a19",
    [SKIN]   = "f4ceb2",
    [CAP]    = "1462e0",
    [EMBLEM]    = "d81c2d",
}

local HEALTH_METER_JEFFY = {
    label = {
        left = get_texture_info("j-back-left"),
        right = get_texture_info("j-back-right"),
    },
    pie = {
        [1] = get_texture_info("j-pie-1"),
        [2] = get_texture_info("j-pie-2"),
        [3] = get_texture_info("j-pie-3"),
        [4] = get_texture_info("j-pie-4"),
        [5] = get_texture_info("j-pie-5"),
        [6] = get_texture_info("j-pie-6"),
        [7] = get_texture_info("j-pie-7"),
        [8] = get_texture_info("j-pie-8"),
    }
}

local CSloaded = false
local function on_character_select_load()
    CT_JEFFY = _G.charSelect.character_add("Jeffy", "Mario and Rosalina's son.", "Chief's Hairline and Toonyrab", {r = 255, g = 186, b = 0}, E_MODEL_JEFFY, CT_MARIO, TEX_CUSTOM_LIFE_ICON)

    _G.charSelect.character_add_voice(E_MODEL_JEFFY, VOICETABLE_JEFFY)
    _G.charSelect.character_add_palette_preset(E_MODEL_JEFFY, PALETTE_JEFFY)
    _G.charSelect.character_add_health_meter(CT_JEFFY, HEALTH_METER_JEFFY)

    CSloaded = true
end

local function on_character_sound(m, sound)
    if not CSloaded then return end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_JEFFY then return _G.charSelect.voice.sound(m, sound) end
end

local function on_character_snore(m)
    if not CSloaded then return end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_JEFFY then return _G.charSelect.voice.snore(m) end
end

hook_event(HOOK_ON_MODS_LOADED, on_character_select_load)
hook_event(HOOK_CHARACTER_SOUND, on_character_sound)
hook_event(HOOK_MARIO_UPDATE, on_character_snore)